/*
 * main.c
 *
 * Author : Andrei Cain
 */
#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include "nokia_5110.h"
#include "bmp_pixel.h"

int main(void) {
	int menu = 0; // menu selection
	int start = 0; // game start
	int pause = 0; // pause
	int i, j;
	
	char xo[3][4] = {"---", "---", "---"}; // x si o matrix
	int xox = 0; // position x in x si o
	int xoy = 0; // position y in x si o
	int xomoves = 9; // x si o total moves
	int xoplayer = 1; // player
	int xowon = 0; // x si o won or not
	
	int pong[3][14] = {{1,1,1,1,1,1,1,1,1,1,1,1,1,1}, // bricks
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1}, {1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
	int pox = 40; // initial position of ball
	int poy = 0; // initial position of ball
	int popal = 33; // initial position of platform
	int pomoves = 42; // total no of bricks
	int polives = 3; // no of lives
	int postart = 0; // game started
	int plx = 0; // speed of ball x
	int ply = 1; // speed of ball y
	int count = 0; // time management
	
	DDRA &= ~(1 << PA7); // pause
	DDRA &= ~(1 << PA1); // down
	DDRA &= ~(1 << PA2); // right
	DDRA &= ~(1 << PA3); // ok
	DDRA &= ~(1 << PA4); // left
	DDRA &= ~(1 << PA5); // up
	DDRA &= ~(1 << PA6); // back
	PORTA |= (1 << PA7);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	
	while (1) {
		LCD_init();
		LCD_clear();
		LCD_draw_bmp_pixel(18, 0, AVR_bmp, 48, 24); // AVR logo
		if (menu == 0 && start == 0) { // Blox selected
			LCD_write_english_string(0, 3,">>>  Blox  <<<");
			LCD_write_english_string(24, 4,"X si O");
			LCD_write_english_string(24, 5,"Despre");
		} else if (menu == 1 && start == 0) { // X si O menu
			LCD_write_english_string(30, 3,"Blox");
			LCD_write_english_string(0, 4,">>> X si O <<<");
			LCD_write_english_string(24, 5,"Despre");
		} else if (menu == 2 && start == 0) { // about menu
			LCD_write_english_string(30, 3,"Blox");
			LCD_write_english_string(24, 4,"X si O");
			LCD_write_english_string(0, 5,">>> Despre <<<");
		} else if (menu == 2 && start == 1) { // about screen
			LCD_write_english_string(12, 0,"Multi Game");
			LCD_write_english_string(12, 1,"HW ver 1.0");
			LCD_write_english_string(12, 2,"SW ver 1.0");
			LCD_write_english_string(6, 3,"------------");
			LCD_write_english_string(6, 4,">Cain Andrei");
			LCD_write_english_string(6, 5,">Grupa 335CA");
			while(1)
				if ((PINA & (1 << PA6)) == 0) // exit about
					break;
		} else if (menu == 0 && start == 1) { // Blox
			while(1) { // game logic
				_delay_ms(15);
				LCD_clear();
				LCD_write_english_string(0, 0, "Blox");
				LCD_write_english_string(66, 0, "V:");
				LCD_write_int(78, 0, polives);
				for (i = 0; i < 14; i++)
					for (j = 0; j < 3; j++) {
						if (pong[j][i] == 1)
							LCD_write_english_string(6*i,j+1,"\\");
					}
				LCD_write_english_string(pox, 4-poy, ".");
				LCD_write_english_string(popal, 5, "---");
				if ((PINA & (1 << PA6)) == 0 || (PINA & (1 << PA7)) == 0) // exit or pause
					break;
				if ((PINA & (1 << PA2)) == 0 && popal < 66) { // right
					popal++;
					if (postart == 0)
						pox++;
				} else if ((PINA & (1 << PA4)) == 0 && popal > 0) { // left
					popal--;
					if (postart == 0)
						pox--;
				} else if ((PINA & (1 << PA3)) == 0 && xo[xox][xoy] == '-') // ok
					postart = 1;
				
				if (pomoves == 0) { // all bricks were destroyed - won
					LCD_clear();
					LCD_write_english_string(0, 0, "Blox");
					LCD_write_english_string(66, 0, "V:");
					LCD_write_int(78, 0, polives);
					LCD_write_english_string(0, 1, "--------------");
					LCD_write_english_string(12, 2, "Felicitari");
					LCD_write_english_string(6, 3, "Ati castigat");
					LCD_write_english_string(0, 4, "--------------");
					LCD_write_english_string(6, 5, "Asteptati 5s");
					_delay_ms(5000);
					start = 0;
					pox = 40;
					poy = 0;
					popal = 33;
					pomoves = 42;
					polives = 3;
					postart = 0;
					for (i = 0; i < 14; i++)
						for (j = 0; j < 3; j++)
							pong[j][i] = 1;
					break;
				}
				if (polives == 0) { // lost all lives - lost
					LCD_clear();
					LCD_write_english_string(0, 0, "Blox");
					LCD_write_english_string(66, 0, "V:");
					LCD_write_int(78, 0, polives);
					LCD_write_english_string(0, 1, "--------------");
					LCD_write_english_string(6, 2, "Imi pare rau");
					LCD_write_english_string(6, 3, "Ati pierdut!");
					LCD_write_english_string(0, 4, "--------------");
					LCD_write_english_string(6, 5, "Asteptati 5s");
					_delay_ms(5000);
					start = 0;
					pox = 40;
					poy = 0;
					popal = 33;
					pomoves = 42;
					polives = 3;
					postart = 0;
					for (i = 0; i < 14; i++)
						for (j = 0; j < 3; j++)
								pong[j][i] = 1;
					break;
				}
				if (postart == 1) { // game started
					count++;
					if (count == 20) {
						pox = pox + plx;
						poy = poy + ply;
						count = 0;
					}
					if (pox < 0) { // left wall collision
						pox = 0;
						plx = 3;
					} else if (pox > 78) { // right wall collision
						pox = 78;
						plx = -3;
					}
					if (4-poy < 1) { // up wall collision
						poy = 2;
						ply = -1;
					} else if (4-poy > 4 && pox + 3 > popal
									&& pox + 2 < popal + 18) { // ball caught
						if (pox + 3 > popal && pox + 2 < popal + 6) {
							plx = -3;
							ply = 1;
						} else if (pox + 3 > popal + 6 && pox + 2 < popal + 12) {
							plx = 0;
							ply = 1;
						} else if (pox + 3 > popal + 12  && pox + 2 < popal + 18) {
							plx = 3;
							ply = 1;
						}
					} else if (4-poy > 4 && 
						(pox + 3 < popal + 1 || pox + 2 > popal + 17)) { // ball lost
						postart = 0;
						poy = 0;
						pox = popal + 7;
						plx = 0;
						ply = 1;
						polives--;
					}
					for (i = 0; i < 14; i++) // brick collision
						for (j = 0; j < 3; j++) {
							if (pong[j][i] == 1 && 4-poy == j+1 && 
								pox + 4 > 6*i && pox + 2 < 6*i+6) {
								pong[j][i] = 0;
								ply = -1;
								pomoves--;
							}
						}
				}
			}
		} else if (menu == 1 && start == 1) { // X si O
			LCD_clear();
			while(1) { // game logic
				LCD_write_english_string(24, 0,"X si O");
				LCD_write_english_string(34, 1, xo[0]);
				LCD_write_english_string(34, 2, xo[1]);
				LCD_write_english_string(34, 3, xo[2]);
				if ((PINA & (1 << PA6)) == 0 || (PINA & (1 << PA7)) == 0) // exit or pause
					break;
				_delay_ms(66);
				LCD_write_english_string(34 + 6*xoy, xox+1, "*");
				_delay_ms(66);
				LCD_write_english_string(22, 4,"Player");
				if (xoplayer == 1)
					LCD_write_english_string(58, 4, "X");
				else if (xoplayer == 2)
					LCD_write_english_string(58, 4, "O");
				if ((PINA & (1 << PA1)) == 0 && xox < 2) { // down
					xox++;
					_delay_ms(262);
				} else if ((PINA & (1 << PA5)) == 0 && xox > 0) { // up
					xox--;
					_delay_ms(262);
				} else if ((PINA & (1 << PA2)) == 0 && xoy < 2) { // right
					xoy++;
					_delay_ms(262);
				} else if ((PINA & (1 << PA4)) == 0 && xoy > 0) { // left
					xoy--;
					_delay_ms(262);
				} else if ((PINA & (1 << PA3)) == 0 && xo[xox][xoy] == '-') { // ok
					if (xoplayer == 1) {
						xo[xox][xoy] = 'X';
						xoplayer = 2;
					} else if (xoplayer == 2) {
						xo[xox][xoy] = 'O';
						xoplayer = 1;
					}
					xomoves--;
					_delay_ms(262);
				}
				// win cases
				if (xo[0][0] == xo[0][1] && xo[0][1] == xo[0][2] && 
					xo[0][0] != '-' && xo[0][1] != '-' && xo[0][2] != '-')
					xowon = 1;
				else if (xo[1][0] == xo[1][1] && xo[1][1] == xo[1][2] &&
					xo[1][0] != '-' && xo[1][1] != '-' && xo[1][2] != '-')
					xowon = 1;
				else if (xo[2][0] == xo[2][1] && xo[2][1] == xo[2][2] &&
					xo[2][0] != '-' && xo[2][1] != '-' && xo[2][2] != '-')
					xowon = 1;
				else if (xo[0][0] == xo[1][0] && xo[1][0] == xo[2][0] &&
					xo[0][0] != '-' && xo[1][0] != '-' && xo[2][0] != '-')
					xowon = 1;
				else if (xo[0][1] == xo[1][1] && xo[1][1] == xo[2][1] &&
					xo[0][1] != '-' && xo[1][1] != '-' && xo[2][1] != '-')
					xowon = 1;
				else if (xo[0][2] == xo[1][2] && xo[1][2] == xo[2][2] &&
					xo[0][2] != '-' && xo[1][2] != '-' && xo[2][2] != '-')
					xowon = 1;
				else if (xo[0][0] == xo[1][1] && xo[1][1] == xo[2][2] &&
					xo[0][0] != '-' && xo[1][1] != '-' && xo[2][2] != '-')
					xowon = 1;
				else if (xo[0][2] == xo[1][1] && xo[1][1] == xo[2][0] &&
					xo[0][2] != '-' && xo[1][1] != '-' && xo[2][0] != '-')
					xowon = 1;
				else if (xomoves == 0 && xowon == 0) { // lost
					LCD_clear();
					LCD_write_english_string(24, 0, "X si O");
					LCD_write_english_string(6, 1, "------------");
					LCD_write_english_string(6, 2, ":( Remiza :(");
					LCD_write_english_string(6, 3, "Joc terminat");
					LCD_write_english_string(6, 4, "------------");
					LCD_write_english_string(6, 5, "Asteptati 5s");
					_delay_ms(5000);
					start = 0;
					xox = 0;
					xoy = 0;
					xomoves = 9;
					xoplayer = 1;
					xowon = 0;
					xo[0][0] = '-';
					xo[0][1] = '-';
					xo[0][2] = '-';
					xo[1][0] = '-';
					xo[1][1] = '-';
					xo[1][2] = '-';
					xo[2][0] = '-';
					xo[2][1] = '-';
					xo[2][2] = '-';
					break;
				}
				if (xowon == 1) { // won
					LCD_clear();
					LCD_write_english_string(24, 0, "X si O");
					LCD_write_english_string(6, 1, "------------");
					LCD_write_english_string(6, 2, "  a castigat");
					if (xoplayer == 1)
						LCD_write_english_string(8, 2, "O");
					else if (xoplayer == 2)
						LCD_write_english_string(8, 2, "X");
					LCD_write_english_string(6, 3, "Joc terminat");
					LCD_write_english_string(6, 4, "------------");
					LCD_write_english_string(6, 5, "Asteptati 5s");
					_delay_ms(5000);
					start = 0;
					xox = 0;
					xoy = 0;
					xomoves = 9;
					xoplayer = 1;
					xowon = 0;
					xo[0][0] = '-';
					xo[0][1] = '-';
					xo[0][2] = '-';
					xo[1][0] = '-';
					xo[1][1] = '-';
					xo[1][2] = '-';
					xo[2][0] = '-';
					xo[2][1] = '-';
					xo[2][2] = '-';
					break;
				}
			}
		}
		if ((PINA & (1 << PA1)) == 0 && menu < 2 && start == 0) // down
			menu++;
		if ((PINA & (1 << PA5)) == 0 && menu > 0 && start == 0) // up
			menu--;
		if ((PINA & (1 << PA3)) == 0 && start == 0) // ok
			start = 1;
		if ((PINA & (1 << PA6)) == 0 && start == 1) // back
			start = 0;
		if ((PINA & (1 << PA7)) == 0 && start == 1 && pause == 0 && menu < 2) // pause
			pause = 1;
		if (pause == 1) { // pause
			LCD_write_english_string(24, 5,">Pauza");
			_delay_ms(393);
			while(1) {
				if ((PINA & (1 << PA7)) == 0) { // exit pause
					pause = 0;
					_delay_ms(131);
					break;
				}
			}
		}
		_delay_ms(131);
	}
	return 0;
}

